package org.richfaces.realworld.service;

import java.io.Serializable;
import java.util.List;

import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;

import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.richfaces.realworld.domain.Image;

@Name("searchService")
public class SearchService implements ISearchService, Serializable
 {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2750591521413940277L;
	//@PersistenceContext(unitName = "entityManager", type=PersistenceContextType.EXTENDED)
	@In(value="entityManager")
	EntityManager em;
	
	/* (non-Javadoc)
	 * @see org.richfaces.realworld.service.ISearchService#searchImages(java.lang.String)
	 */
	@Begin(join=true)
	public List<Image> searchImages(String searchPattern){
		List<Image> images = em.createQuery("select i from MetaTag t join t.parent i where t.tag like:metatag and i.album.shared=true order by i.rank.total/i.rank.hits desc").setParameter("metatag", searchPattern+"%").getResultList();
		return images;
	}
	
	@Begin(join=true)
	public List<Image> popularImages(){
		List<Image> images = em.createQuery("select i from Image i join i.rank r where i.album.shared=true order by r.total/r.hits desc").setMaxResults(10).getResultList();
		return images;
	}
	
	@Begin(join=true)
	public List<Image> worstImages(){
		List<Image> images = em.createQuery("select i from Image i join i.rank r where i.album.shared=true order by r.total/r.hits asc").setMaxResults(10).getResultList();
		return images;
	}
	
	/* (non-Javadoc)
	 * @see org.richfaces.realworld.service.IAlbumAction#remove()
	 */
	@Remove
	public void remove(){
		
	}
	
	/* (non-Javadoc)
	 * @see org.richfaces.realworld.service.IAlbumAction#destroy()
	 */
	@Destroy
	public void destroy(){
		
	}
}
